diff -Naur -x '*.dia' -x '*.pcap' ns-3.30.1/src/lr-wpan/model/lr-wpan-csmaca.cc ns-3.31/src/lr-wpan/model/lr-wpan-csmaca.cc
--- ns-3.30.1/src/lr-wpan/model/lr-wpan-csmaca.cc	2019-08-12 16:30:34.000000000 -0700
+++ ns-3.31/src/lr-wpan/model/lr-wpan-csmaca.cc	2020-06-27 17:38:30.000000000 -0700
@@ -18,6 +18,7 @@
  * Author:
  *  kwong yin <kwong-sang.yin@boeing.com>
  *  Sascha Alexander Jopen <jopen@cs.uni-bonn.de>
+ *  Alberto Gallegos Ramonet <ramonet@fc.ritsumei.ac.jp>
  */
 
 #include "lr-wpan-csmaca.h"
@@ -26,6 +27,10 @@
 #include <ns3/log.h>
 #include <algorithm>
 
+#undef NS_LOG_APPEND_CONTEXT
+#define NS_LOG_APPEND_CONTEXT                                   \
+  std::clog << "[address " << m_mac->GetShortAddress () << "] ";
+
 namespace ns3 {
 
 NS_LOG_COMPONENT_DEFINE ("LrWpanCsmaCa");
@@ -50,14 +55,16 @@
   m_isSlotted = false;
   m_NB = 0;
   m_CW = 2;
-  m_BLE = false;
+  m_macBattLifeExt = false;
   m_macMinBE = 3;
   m_macMaxBE = 5;
   m_macMaxCSMABackoffs = 4;
-  m_aUnitBackoffPeriod = 20; //20 symbols
+  m_aUnitBackoffPeriod = 20; // symbols
   m_random = CreateObject<UniformRandomVariable> ();
   m_BE = m_macMinBE;
   m_ccaRequestRunning = false;
+  m_randomBackoffPeriodsLeft = 0;
+  m_coorDest = false;
 }
 
 LrWpanCsmaCa::~LrWpanCsmaCa ()
@@ -68,7 +75,9 @@
 void
 LrWpanCsmaCa::DoDispose ()
 {
-  m_lrWpanMacStateCallback = MakeNullCallback< void, LrWpanMacState> ();
+  m_lrWpanMacStateCallback = MakeNullCallback <void, LrWpanMacState> ();
+  m_lrWpanMacTransCostCallback = MakeNullCallback <void, uint32_t> ();
+
   Cancel ();
   m_mac = 0;
 }
@@ -169,26 +178,85 @@
   return m_aUnitBackoffPeriod;
 }
 
+
 Time
 LrWpanCsmaCa::GetTimeToNextSlot (void) const
 {
   NS_LOG_FUNCTION (this);
 
-  // TODO: Calculate the offset to the next slot.
+  // The reference for the beginning of the SUPERFRAME (the active period) changes depending
+  // on the data packet being sent from the Coordinator/outgoing frame (Tx beacon time reference)
+  // or other device/incoming frame (Rx beacon time reference ).
+
+  Time elapsedSuperframe;  // (i.e  The beacon + the elapsed CAP)
+  Time currentTime;
+  double symbolsToBoundary;
+  Time nextBoundary;
+  uint64_t elapsedSuperframeSymbols;
+  uint64_t symbolRate;
+  Time timeAtBoundary;
+  Time elapsedCap;
+  Time beaconTime;
+
+
+  currentTime = Simulator::Now ();
+  symbolRate = (uint64_t) m_mac->GetPhy ()->GetDataOrSymbolRate (false); //symbols per second
+
+  if (m_coorDest)
+    {
+      // Take the Incoming Frame Reference
+      elapsedSuperframe = currentTime - m_mac->m_macBeaconRxTime;
+
+      beaconTime = Seconds ((double) m_mac->m_rxBeaconSymbols / symbolRate);
+      elapsedCap = elapsedSuperframe - beaconTime;
+      NS_LOG_DEBUG ("Elapsed incoming CAP symbols: " << (elapsedCap.GetSeconds () * symbolRate)  << " (" << elapsedCap.As (Time::S) << ")");
+      NS_UNUSED (beaconTime);
+      NS_UNUSED (elapsedCap);
+    }
+  else
+    {
+      // Take the Outgoing Frame Reference
+      elapsedSuperframe = currentTime - m_mac->m_macBeaconTxTime;
+    }
+
+  // get a close value to the the boundary in symbols
+  elapsedSuperframeSymbols = elapsedSuperframe.GetSeconds () * symbolRate;
+  symbolsToBoundary = m_aUnitBackoffPeriod - std::fmod ((double) elapsedSuperframeSymbols,m_aUnitBackoffPeriod);
+
+  timeAtBoundary = Seconds ((double)(elapsedSuperframeSymbols + symbolsToBoundary) / symbolRate);
+
+  // get the exact time boundary
+  nextBoundary = timeAtBoundary - elapsedSuperframe;
+
+  NS_LOG_DEBUG ("Elapsed Superframe symbols: " << elapsedSuperframeSymbols << " ("
+                                               << elapsedSuperframe.As (Time::S) << ")");
+
+  NS_LOG_DEBUG ("Next backoff period boundary in approx. " << nextBoundary.GetSeconds () * symbolRate << " symbols ("
+                                                           << nextBoundary.As (Time::S) << ")");
 
-  return Seconds (0);
+  return nextBoundary;
 
 }
+
+
 void
 LrWpanCsmaCa::Start ()
-
 {
   NS_LOG_FUNCTION (this);
   m_NB = 0;
   if (IsSlottedCsmaCa ())
     {
+      // TODO: Check if the current PHY is using the Japanese band 950 Mhz:
+      //       (IEEE_802_15_4_950MHZ_BPSK and IEEE_802_15_4_950MHZ_2GFSK)
+      //       if in use, m_CW = 1.
+      //       Currently 950 Mhz band PHYs are not supported in ns-3.
+      //       To know the current used PHY, making the method for GetPhy()->GetMyPhyOption()
+      //       public is necessary. Alternatively, the current PHY used
+      //       can be known using phyCurrentPage variable.
+
       m_CW = 2;
-      if (m_BLE)
+
+      if (m_macBattLifeExt)
         {
           m_BE = std::min (static_cast<uint8_t> (2), m_macMinBE);
         }
@@ -196,23 +264,20 @@
         {
           m_BE = m_macMinBE;
         }
-      //TODO: for slotted, locate backoff period boundary. i.e. delay to the next slot boundary
+
+      // m_coorDest to decide between incoming and outgoing superframes times
+      m_coorDest = m_mac->isCoordDest ();
+
+      // Locate backoff period boundary. (i.e. a time delay to align with the next backoff period boundary)
       Time backoffBoundary = GetTimeToNextSlot ();
       m_randomBackoffEvent = Simulator::Schedule (backoffBoundary, &LrWpanCsmaCa::RandomBackoffDelay, this);
+
     }
   else
     {
       m_BE = m_macMinBE;
       m_randomBackoffEvent = Simulator::ScheduleNow (&LrWpanCsmaCa::RandomBackoffDelay, this);
     }
-  /*
-  *  TODO: If using Backoff.cc (will need to modify Backoff::GetBackoffTime)
-  *        Backoff.m_minSlots = 0;
-  *        Backoff.m_ceiling = m_BE;
-  *        Backoff.ResetBackoffTime(); //m_NB is same as m_numBackoffRetries in Backoff.h
-  *        Backoff.m_maxRetries = macMaxCSMABackoffs;
-  *        Backoff.m_slotTime = m_backoffPeriod;
-  */
 }
 
 void
@@ -223,65 +288,176 @@
   m_canProceedEvent.Cancel ();
 }
 
-/*
- * Delay for backoff period in the range 0 to 2^BE -1 units
- * TODO: If using Backoff.cc (Backoff::GetBackoffTime) will need to be slightly modified
- */
+
+
 void
 LrWpanCsmaCa::RandomBackoffDelay ()
 {
   NS_LOG_FUNCTION (this);
 
   uint64_t upperBound = (uint64_t) pow (2, m_BE) - 1;
-  uint64_t backoffPeriod;
   Time randomBackoff;
   uint64_t symbolRate;
-  bool isData = false;
+  Time timeLeftInCap;
+
+  symbolRate = (uint64_t) m_mac->GetPhy ()->GetDataOrSymbolRate (false); //symbols per second
 
+  // We should not recalculate the random backoffPeriods if we are in a slotted CSMA-CA and the
+  // transmission was previously deferred (m_randomBackoffPeriods != 0)
+  if (m_randomBackoffPeriodsLeft == 0 || IsUnSlottedCsmaCa ())
+    {
+      m_randomBackoffPeriodsLeft = (uint64_t)m_random->GetValue (0, upperBound + 1);
+    }
 
-  symbolRate = (uint64_t) m_mac->GetPhy ()->GetDataOrSymbolRate (isData); //symbols per second
-  backoffPeriod = (uint64_t)m_random->GetValue (0, upperBound+1); // num backoff periods
-  randomBackoff = MicroSeconds (backoffPeriod * GetUnitBackoffPeriod () * 1000 * 1000 / symbolRate);
+  randomBackoff = Seconds ((double) (m_randomBackoffPeriodsLeft * GetUnitBackoffPeriod ()) / symbolRate);
 
   if (IsUnSlottedCsmaCa ())
     {
-      NS_LOG_LOGIC ("Unslotted:  requesting CCA after backoff of " << randomBackoff.GetMicroSeconds () << " us");
+      NS_LOG_DEBUG ("Unslotted CSMA-CA: requesting CCA after backoff of " << m_randomBackoffPeriodsLeft <<
+                    " periods (" << randomBackoff.As (Time::S) << ")");
       m_requestCcaEvent = Simulator::Schedule (randomBackoff, &LrWpanCsmaCa::RequestCCA, this);
     }
   else
     {
-      NS_LOG_LOGIC ("Slotted:  proceeding after backoff of " << randomBackoff.GetMicroSeconds () << " us");
-      m_canProceedEvent = Simulator::Schedule (randomBackoff, &LrWpanCsmaCa::CanProceed, this);
+      // We must make sure there is enough time left in the CAP, otherwise we continue in
+      // the CAP of the next superframe after the transmission/reception of the beacon (and the IFS)
+      timeLeftInCap = GetTimeLeftInCap ();
+
+      NS_LOG_DEBUG ("Slotted CSMA-CA: proceeding after random backoff of " << m_randomBackoffPeriodsLeft <<
+                    " periods ("  << (randomBackoff.GetSeconds () * symbolRate) << " symbols or " << randomBackoff.As (Time::S) << ")");
+
+
+
+
+      NS_LOG_DEBUG ("Backoff periods left in CAP: " << ((timeLeftInCap.GetSeconds () *  symbolRate) / m_aUnitBackoffPeriod) << " ("
+                                                    << (timeLeftInCap.GetSeconds () *  symbolRate) << " symbols or "
+                                                    << timeLeftInCap.As (Time::S) << ")");
+
+
+      if (randomBackoff > timeLeftInCap)
+        {
+          uint64_t usedBackoffs = (double)(timeLeftInCap.GetSeconds () *  symbolRate) / m_aUnitBackoffPeriod;
+          m_randomBackoffPeriodsLeft -= usedBackoffs;
+          NS_LOG_DEBUG ("No time in CAP to complete backoff delay, deferring to the next CAP");
+          m_endCapEvent = Simulator::Schedule (timeLeftInCap, &LrWpanCsmaCa::DeferCsmaTimeout, this);
+        }
+      else
+        {
+          m_canProceedEvent = Simulator::Schedule (randomBackoff, &LrWpanCsmaCa::CanProceed, this);
+        }
+    }
+}
+
+
+Time
+LrWpanCsmaCa::GetTimeLeftInCap ()
+{
+  Time currentTime;
+  uint64_t capSymbols;
+  Time endCapTime;
+  uint64_t activeSlot;
+  uint64_t symbolRate;
+  Time rxBeaconTime;
+
+
+  // At this point, the currentTime should be aligned on a backoff period boundary
+  currentTime  = Simulator::Now ();
+  symbolRate = (uint64_t) m_mac->GetPhy ()->GetDataOrSymbolRate (false); //symbols per second
+
+
+  if (m_coorDest)
+    { // Take Incoming frame reference
+      activeSlot = m_mac->m_incomingSuperframeDuration / 16;
+      capSymbols = activeSlot * (m_mac->m_incomingFnlCapSlot + 1);
+      endCapTime = m_mac->m_macBeaconRxTime +
+        Seconds ((double) capSymbols / symbolRate);
+    }
+  else
+    { // Take Outgoing frame reference
+      activeSlot = m_mac->m_superframeDuration / 16;
+      capSymbols = activeSlot * (m_mac->m_fnlCapSlot + 1);
+      endCapTime = m_mac->m_macBeaconTxTime +
+        Seconds ((double) capSymbols / symbolRate);
     }
+
+  return (endCapTime - currentTime);
 }
 
-// TODO : Determine if transmission can be completed before end of CAP for the slotted csmaca
-//        If not delay to the next CAP
+
 void
 LrWpanCsmaCa::CanProceed ()
 {
   NS_LOG_FUNCTION (this);
 
-  bool canProceed = true;
+  Time timeLeftInCap;
+  uint16_t ccaSymbols;
+  uint32_t transactionSymbols;
+  Time transactionTime;
+  uint64_t symbolRate;
+
+  ccaSymbols = 0;
+  m_randomBackoffPeriodsLeft = 0;
+  symbolRate = (uint64_t) m_mac->GetPhy ()->GetDataOrSymbolRate (false);
+  timeLeftInCap = GetTimeLeftInCap ();
+
+
+  // TODO: On the 950 Mhz Band (Japanese Band)
+  //       only a single CCA check is performed;
+  //       the CCA check duration time is:
+  //
+  //       CCA symbols = phyCCADuration * m_CW (1)
+  //       other PHYs:
+  //       CCA symbols = 8 * m_CW(2)
+  //
+  //       note: phyCCADuration & 950Mhz band PHYs are
+  //             not currently implemented in ns-3.
+  ccaSymbols += 8 * m_CW;
+
+  // The MAC sublayer shall proceed if the remaining CSMA-CA algorithm steps
+  // can be completed before the end of the CAP.
+  // See IEEE 802.15.4-2011 (Sections 5.1.1.1 and 5.1.1.4)
+  // Transaction = 2 CCA + frame transmission (SHR+PHR+PPDU) + turnaroudtime*2 (Rx->Tx & Tx->Rx) + IFS (LIFS or SIFS) and Ack time (if ack flag true)
+
+  transactionSymbols = ccaSymbols + m_mac->GetTxPacketSymbols ();
 
-  if (m_BLE)
+  if (m_mac->isTxAckReq ())
     {
+      NS_LOG_DEBUG ("ACK duration symbols: " <<  m_mac->GetMacAckWaitDuration ());
+      transactionSymbols +=  m_mac->GetMacAckWaitDuration ();
     }
   else
     {
+      //time the PHY takes to switch from Rx to Tx and Tx to Rx
+      transactionSymbols += (m_mac->GetPhy ()->aTurnaroundTime *2);
     }
+  transactionSymbols +=  m_mac->GetIfsSize ();
 
-  if (canProceed)
+  // Report the transaction cost
+  if (!m_lrWpanMacTransCostCallback.IsNull ())
     {
-      // TODO: For slotted, Perform CCA on backoff period boundary i.e. delay to next slot boundary
-      Time backoffBoundary = GetTimeToNextSlot ();
-      m_requestCcaEvent = Simulator::Schedule (backoffBoundary, &LrWpanCsmaCa::RequestCCA, this);
+      m_lrWpanMacTransCostCallback (transactionSymbols);
+    }
+
+  transactionTime = Seconds ((double) transactionSymbols / symbolRate);
+  NS_LOG_DEBUG ("Total required transaction: " << transactionSymbols << " symbols (" << transactionTime.As (Time::S) << ")");
+
+  if (transactionTime > timeLeftInCap)
+    {
+      NS_LOG_DEBUG ("Transaction of " << transactionSymbols << " symbols " <<
+                    "cannot be completed in CAP, deferring transmission to the next CAP");
+
+
+
+      NS_LOG_DEBUG ("Symbols left in CAP: " << (timeLeftInCap.GetSeconds () * symbolRate) <<
+                    " (" << timeLeftInCap.As (Time::S) << ")");
+
+      m_endCapEvent = Simulator::Schedule (timeLeftInCap, &LrWpanCsmaCa::DeferCsmaTimeout, this);
     }
   else
     {
-      Time nextCap = Seconds (0);
-      m_randomBackoffEvent = Simulator::Schedule (nextCap, &LrWpanCsmaCa::RandomBackoffDelay, this);
+      m_requestCcaEvent = Simulator::ScheduleNow (&LrWpanCsmaCa::RequestCCA,this);
     }
+
 }
 
 void
@@ -292,9 +468,13 @@
   m_mac->GetPhy ()->PlmeCcaRequest ();
 }
 
-/*
- * This function is called when the phy calls back after completing a PlmeCcaRequest
- */
+void
+LrWpanCsmaCa::DeferCsmaTimeout ()
+{
+  NS_LOG_FUNCTION (this);
+  m_lrWpanMacStateCallback (MAC_CSMA_DEFERRED);
+}
+
 void
 LrWpanCsmaCa::PlmeCcaConfirm (LrWpanPhyEnumeration status)
 {
@@ -364,6 +544,15 @@
     }
 }
 
+
+void
+LrWpanCsmaCa::SetLrWpanMacTransCostCallback (LrWpanMacTransCostCallback c)
+{
+  NS_LOG_FUNCTION (this);
+  m_lrWpanMacTransCostCallback = c;
+}
+
+
 void
 LrWpanCsmaCa::SetLrWpanMacStateCallback (LrWpanMacStateCallback c)
 {
@@ -371,6 +560,13 @@
   m_lrWpanMacStateCallback = c;
 }
 
+void
+LrWpanCsmaCa::SetBatteryLifeExtension (bool batteryLifeExtension)
+{
+  m_macBattLifeExt = batteryLifeExtension;
+}
+
+
 int64_t
 LrWpanCsmaCa::AssignStreams (int64_t stream)
 {
@@ -385,4 +581,10 @@
   return m_NB;
 }
 
+bool
+LrWpanCsmaCa::GetBatteryLifeExtension (void)
+{
+  return m_macBattLifeExt;
+}
+
 } //namespace ns3
diff -Naur -x '*.dia' -x '*.pcap' ns-3.30.1/src/lr-wpan/model/lr-wpan-csmaca.h ns-3.31/src/lr-wpan/model/lr-wpan-csmaca.h
--- ns-3.30.1/src/lr-wpan/model/lr-wpan-csmaca.h	2019-08-12 16:30:34.000000000 -0700
+++ ns-3.31/src/lr-wpan/model/lr-wpan-csmaca.h	2020-06-27 17:38:30.000000000 -0700
@@ -18,6 +18,7 @@
  * Author:
  *  kwong yin <kwong-sang.yin@boeing.com>
  *  Sascha Alexander Jopen <jopen@cs.uni-bonn.de>
+ *  Alberto Gallegos Ramonet <ramonet@fc.ritsumei.ac.jp>
  */
 
 #ifndef LR_WPAN_CSMACA_H
@@ -34,10 +35,18 @@
 /**
  * \ingroup lr-wpan
  *
- * This method informs the MAC  whether the channel is idle or busy.
+ * This method informs the MAC whether the channel is idle or busy.
  */
 typedef Callback<void, LrWpanMacState> LrWpanMacStateCallback;
-
+/**
+ * \ingroup lr-wpan
+ *
+ * This method informs the transaction cost in a slotted CSMA-CA data transmission.
+ * i.e. Reports number of symbols (time) it would take slotted CSMA-CA to process the current transaction.
+ * 1 Transaction = 2 CCA + frame transmission (PPDU) + turnaroudtime or Ack time (optional) + IFS
+ * See IEEE 802.15.4-2011 (Sections 5.1.1.1 and 5.1.1.4)
+ */
+typedef Callback<void, uint32_t> LrWpanMacTransCostCallback;
 /**
  * \ingroup lr-wpan
  *
@@ -54,20 +63,17 @@
    * \return the object TypeId
    */
   static TypeId GetTypeId (void);
-
   /**
    * Default constructor.
    */
   LrWpanCsmaCa (void);
   virtual ~LrWpanCsmaCa (void);
-
   /**
    * Set the MAC to which this CSMA/CA implementation is attached to.
    *
    * \param mac the used MAC
    */
   void SetMac (Ptr<LrWpanMac> mac);
-
   /**
    * Get the MAC to which this CSMA/CA implementation is attached to.
    *
@@ -79,26 +85,22 @@
    * Configure for the use of the slotted CSMA/CA version.
    */
   void SetSlottedCsmaCa (void);
-
   /**
    * Configure for the use of the unslotted CSMA/CA version.
    */
   void SetUnSlottedCsmaCa (void);
-
   /**
    * Check if the slotted CSMA/CA version is being used.
    *
    * \return true, if slotted CSMA/CA is used, false otherwise.
    */
   bool IsSlottedCsmaCa (void) const;
-
   /**
    * Check if the unslotted CSMA/CA version is being used.
    *
    * \return true, if unslotted CSMA/CA is used, false otherwise.
    */
   bool IsUnSlottedCsmaCa (void) const;
-
   /**
    * Set the minimum backoff exponent value.
    * See IEEE 802.15.4-2006, section 7.4.2, Table 86.
@@ -106,7 +108,6 @@
    * \param macMinBE the minimum backoff exponent value
    */
   void SetMacMinBE (uint8_t macMinBE);
-
   /**
    * Get the minimum backoff exponent value.
    * See IEEE 802.15.4-2006, section 7.4.2, Table 86.
@@ -114,7 +115,6 @@
    * \return the minimum backoff exponent value
    */
   uint8_t GetMacMinBE (void) const;
-
   /**
    * Set the maximum backoff exponent value.
    * See IEEE 802.15.4-2006, section 7.4.2, Table 86.
@@ -122,7 +122,6 @@
    * \param macMaxBE the maximum backoff exponent value
    */
   void SetMacMaxBE (uint8_t macMaxBE);
-
   /**
    * Get the maximum backoff exponent value.
    * See IEEE 802.15.4-2006, section 7.4.2, Table 86.
@@ -130,7 +129,6 @@
    * \return the maximum backoff exponent value
    */
   uint8_t GetMacMaxBE (void) const;
-
   /**
    * Set the maximum number of backoffs.
    * See IEEE 802.15.4-2006, section 7.4.2, Table 86.
@@ -146,7 +144,6 @@
    * \return the maximum number of backoffs
    */
   uint8_t GetMacMaxCSMABackoffs (void) const;
-
   /**
    * Set the number of symbols forming the basic time period used by the
    * CSMA-CA algorithm.
@@ -155,7 +152,6 @@
    * \param unitBackoffPeriod the period length in symbols
    */
   void SetUnitBackoffPeriod (uint64_t unitBackoffPeriod);
-
   /**
    * Get the number of symbols forming the basic time period used by the
    * CSMA-CA algorithm.
@@ -164,30 +160,26 @@
    * \return the period length in symbols
    */
   uint64_t GetUnitBackoffPeriod (void) const;
-
   /**
-   * Get the amount of time from now to the beginning of the next slot.
+   * Locates the time to the next backoff period boundary in the SUPERFRAME
+   * and returns the amount of time left to this moment.
    *
    * \return time offset to the next slot
    */
   Time GetTimeToNextSlot (void) const;
-
   /**
    * Start CSMA-CA algorithm (step 1), initialize NB, BE for both slotted and unslotted
-   * CSMA-CA. For the slotted initialize CW plus also start on the backoff boundary
+   * CSMA-CA. For slotted CSMA-CA initializes CW and starts the backoff slot count.
    */
   void Start (void);
-
   /**
    * Cancel CSMA-CA algorithm.
    */
   void Cancel (void);
-
   /**
    * In step 2 of the CSMA-CA, perform a random backoff in the range of 0 to 2^BE -1
    */
   void RandomBackoffDelay (void);
-
   /**
    * In the slotted CSMA-CA, after random backoff, determine if the remaining
    * CSMA-CA operation can proceed, i.e. can the entire transactions can be
@@ -196,12 +188,15 @@
    * proceed function RequestCCA() is called.
    */
   void CanProceed (void);
-
   /**
    * Request the Phy to perform CCA (Step 3)
    */
   void RequestCCA (void);
-
+  /**
+   * The CSMA algorithm call this function at the end of the CAP to return the MAC state
+   * back to to IDLE after a transmission was deferred due to the lack of time in the CAP.
+   */
+  void DeferCsmaTimeout (void);
   /**
    *  IEEE 802.15.4-2006 section 6.2.2.2
    *  PLME-CCA.confirm status
@@ -214,7 +209,14 @@
    * treat as channel access failure (step 4).
    */
   void PlmeCcaConfirm (LrWpanPhyEnumeration status);
-
+  /**
+   * Set the callback function to report a transaction cost in slotted CSMA-CA. The callback is
+   * triggered in CanProceed() after calculating the transaction cost (2 CCA checks,transmission cost, turnAroundTime, ifs)
+   * in the boundary of an Active Period.
+   *
+   * \param trans the transaction cost callback
+   */
+  void SetLrWpanMacTransCostCallback (LrWpanMacTransCostCallback trans);
   /**
    * Set the callback function to the MAC. Used at the end of a Channel Assessment, as part of the
    * interconnections between the CSMA-CA and the MAC. The callback
@@ -223,7 +225,12 @@
    * \param macState the mac state callback
    */
   void SetLrWpanMacStateCallback (LrWpanMacStateCallback macState);
-
+  /**
+   * Set the value of the Battery Life Extension
+   *
+   * \param batteryLifeExtension the Battery Life Extension value active or inactive
+   */
+  void SetBatteryLifeExtension (bool batteryLifeExtension);
   /**
    * Assign a fixed random variable stream number to the random variables
    * used by this model.  Return the number of streams that have been assigned.
@@ -232,13 +239,18 @@
    * \return the number of stream indices assigned by this model
    */
   int64_t AssignStreams (int64_t stream);
-
   /**
    * Get the number of CSMA retries
    *
    * \returns the number of CSMA retries
    */
   uint8_t GetNB (void);
+  /**
+   * Get the value of the Battery Life Extension
+   *
+   * \returns  true or false to Battery Life Extension support
+   */
+  bool GetBatteryLifeExtension (void);
 
 private:
   // Disable implicit copy constructors
@@ -251,90 +263,98 @@
    * \returns
    */
   LrWpanCsmaCa& operator= (LrWpanCsmaCa const &);
- 
-  virtual void DoDispose (void);
 
+  virtual void DoDispose (void);
+  /**
+   *  \brief Get the time left in the CAP portion of the Outgoing or Incoming superframe.
+   *  \return the time left in the CAP
+   */
+  Time GetTimeLeftInCap ();
+  /**
+   * The callback to inform the cost of a transaction in slotted CSMA-CA.
+   */
+  LrWpanMacTransCostCallback m_lrWpanMacTransCostCallback;
   /**
    * The callback to inform the configured MAC of the CSMA/CA result.
    */
   LrWpanMacStateCallback m_lrWpanMacStateCallback;
-
   /**
    * Beacon-enabled slotted or nonbeacon-enabled unslotted CSMA-CA.
    */
   bool m_isSlotted;
-
   /**
-   * The MAC instance for which this CSMAÃ„/CA implementation is configured.
+   * The MAC instance for which this CSMA/CA implemenation is configured.
    */
   Ptr<LrWpanMac> m_mac;
-
   /**
    * Number of backoffs for the current transmission.
    */
   uint8_t m_NB;
-
   /**
    * Contention window length (used in slotted ver only).
    */
   uint8_t m_CW;
-
   /**
    * Backoff exponent.
    */
   uint8_t m_BE;
-
   /**
    * Battery Life Extension.
    */
-  bool m_BLE;
-
+  bool m_macBattLifeExt;
   /**
    * Minimum backoff exponent. 0 - macMaxBE, default 3
    */
   uint8_t m_macMinBE;                   //
-
   /**
    * Maximum backoff exponent. 3 - 8, default 5
    */
   uint8_t m_macMaxBE;
-
   /**
    * Maximum number of backoffs. 0 - 5, default 4
    */
   uint8_t m_macMaxCSMABackoffs;
-
   /**
    * Number of symbols per CSMA/CA time unit, default 20 symbols.
    */
   uint64_t m_aUnitBackoffPeriod;
-
+  /**
+   * Count the number of remaining random backoff periods left to delay.
+   */
+  uint64_t m_randomBackoffPeriodsLeft;
   /**
    * Uniform random variable stream.
    */
   Ptr<UniformRandomVariable> m_random;
-
   /**
    * Scheduler event for the start of the next random backoff/slot.
    */
   EventId m_randomBackoffEvent;
-
+  /**
+   * Scheduler event for the end of the current CAP
+   */
+  EventId m_endCapEvent;
   /**
    * Scheduler event when to start the CCA after a random backoff.
    */
   EventId m_requestCcaEvent;
-
   /**
    * Scheduler event for checking if we can complete the transmission before the
    * end of the CAP.
    */
   EventId m_canProceedEvent;
-
   /**
    * Flag indicating that the PHY is currently running a CCA. Used to prevent
    * reporting the channel status to the MAC while canceling the CSMA algorithm.
    */
   bool m_ccaRequestRunning;
+  /**
+   * Indicates whether the CSMA procedure is targeted for a message to be sent to the coordinator.
+   * Used to run slotted CSMA/CA on the incoming or outgoing superframe
+   * according to the target.
+   */
+  bool m_coorDest;
+
 };
 
 }
